#include "CuboidElastin.h"
#include "SimuContext.h"
#include <math.h>

CuboidElastin::CuboidElastin(){
  SimuContext* context = SimuContext::getInstance();
  diagonalLength = sqrt( pow(context->getElementWidth(), 2.0f)
                       + pow(context->getElementHeight(), 2.0f)
                       + pow(context->getElementDepth(), 2.0f)
                       );
}

CuboidElastin::~CuboidElastin(){}

bool CuboidElastin::collideWith(DLAElement* pE){ 
  float ty = y + vy; //speed * sin(alphaAngle);
  float tx = x + vx; //speed * cos(alphaAngle) * cos(thetaAngle);
  float tz = z + vz; //speed * cos(alphaAngle) * sin(thetaAngle);

  //float distance = pE->distanceTo(tx, ty, tz); //centerDistance(pE);
  SimuContext* context = SimuContext::getInstance();
  if(  fabs(tx - pE->getX()) <= context->getElementWidth()
    && fabs(ty - pE->getY()) <= context->getElementHeight()
    && fabs(tz - pE->getZ()) <= context->getElementDepth()    
    ){
    return true;
  }
  return false;
}

//void  CuboidElastin::stuckWith(DLAElement* pE){
//}
void  CuboidElastin::attach(DLAElement* /*pE*/){
}

bool CuboidElastin::isAdjustable(DLAElement* /*pComing*/, float /*stepSize*/, float& /*adjustAngle*/, float& /*adjustDistance*/, DLAElement*& /*pOccupy*/){
	return false;
}
bool  CuboidElastin::positionOccupied(float /*angle*/, float /*xPos*/, DLAElement*& /*pElm*/){
  return false;
}    
