#ifndef CYLINDERELASTIN_H
#define CYLINDERELASTIN_H

#include <list>
#include "DLAElement.h"
#include "Aggregate.h"
#include "SimuContext.h"

class CylinderElastin : public DLA3DElement{

  public:
    CylinderElastin();
    virtual ~CylinderElastin();
    virtual bool  collideWith(DLAElement* targetElement);
    //virtual void  stuckWith(DLAElement* pE);
    /**
     * Attach an element to the current element
     * @param pE Pointer to the coming element
     * 
     */
    virtual void  attach(DLAElement* pE);
    virtual bool  collideTest(float nx, float ny, float nz, DLAElement* pE);
    virtual bool  positionOccupied(float angle, float xPos, DLAElement*& pElm);
    
    /**
     * Test whether the new coming particle's position is adjustable to the potential target
     * in the aggregate.
     * @param pComing  Pointer to the coming particle
     * @param stepSize The radian angle size for each adjustment, when stepSize > 0, 
     * 								 adjust counterclockwisely; when stepSize < 0, adjust clockwisely   
     * @param adjustAngle  
     * @return 
     */
    virtual bool isAdjustable(DLAElement* pComing, float stepSize, float& adjustAngle, float& newDistance, DLAElement*& pOccupy);
};

#endif
