#ifndef DATACOLLECTOR_H_
#define DATACOLLECTOR_H_

#include <map>
#include <iostream>
#include "Aggregate.h"

using namespace std;

/**
 * Class for statistical data collection of the simulation trace. 
 * 
 */
class DataCollector
{
public:
	DataCollector();
	DataCollector(Aggregate* pAgg);
	virtual    ~DataCollector();	
	Aggregate* getAggregate();
	void       setAggregate(Aggregate* pAgg);
	void       collectData();
    //ostream&  save(ostream& outStr);  
	friend     ostream& operator<<(ostream& outStr, const DataCollector& dCollector);
	
protected:
  Aggregate*       pAggregate;
  float            averageTime;
  float            density;
  float            surfaceArea;
  float            averageConnectivity; // The average number of neighbours of particles in the aggregate.
  float            aggLength;
  float            averageCrossNeighbours;
  map<int, int>    connectivityMap;
  map<float, int>  distToCenterMap;
};

#endif /*DATACOLLECTOR_H_*/
