#ifndef POINT2D_HPP_
#define POINT2D_HPP_
//#include "Vector2D.hpp"
#include <iostream>

template <typename T>
class Point2D
{
public:
	
	Point2D(){
		m_x = T();
		m_y = T();
		m_id  = 0;
	}
	
	Point2D(T x, T y, unsigned int id=0){
		m_x = x;
		m_y = y;
		m_id = id;
	}
	
	virtual ~Point2D(){};
	
	//Vector2D<T> operator-(const Ponit2D<T>& rhs){
	//	Vector2D<T> tmpVec(m_x - rhs.x(), m_y - rhs.y());
	//	return tmpVec;
	//}
	
	T x() const{
		return m_x;
	}
	
	T y() const{
		return m_y;
	}

	void setPosition(T x, T y){
		m_x = x;
		m_y = y;
	}
	
	unsigned int id() const{
		return m_id;
	}
	
	void setId(unsigned int id){
		m_id = id;
	}
	
	T distance(const Point2D<T>& rhs){
		return sqrt((m_x-rhs.x())*(m_x-rhs.x()) + (m_y-rhs.y())*(m_y-rhs.y()));
	}
	
private:
	T m_x;
	T m_y;
	unsigned int m_id;
};

template <typename T>
std::ostream& operator<<(std::ostream& ostr, const Point2D<T>& point){
	ostr << "(" << point.id() << ": " << point.x() << ", " << point.y() << ")";
	return ostr;
}

#endif /*PONIT2D_H_*/
