#ifndef POINTBAG2D_HPP_
#define POINTBAG2D_HPP_

#include "Point2D.hpp"
#include "Vector2D.hpp"

#include <list>
#include <algorithm>
#include <iostream>

//using namespace std;
//template <typename V>
//class XFuncObject{
//bool operator()(const V& p1, const V& p2){
//	return (p1.x() < p2.x());
//};

template <typename V>
bool xFunc(V p1, V p2){
	return p1.x() < p2.x();
}

template <typename W>
bool yFunc(W p1, W p2){
	return p1.y() < p2.y();
}

template <typename T>
class PointBag2D{
public:
	PointBag2D(){		
	}
	
	PointBag2D(const std::list<T>& pList ){
		m_pointsList = pList;
	}
	
	void addPoints(const std::list<T>& pList ){
		m_pointsList.insert(m_pointsList.end(), pList.begin(), pList.end());
	}
	
	void addPoint(const T& newPoint){
		m_pointsList.push_back(newPoint);
	}
	
	unsigned int numberOfPoints(){
		return m_pointsList.size();
	}
	
	std::list<T> getAllPoints() const{
		return m_pointsList; 
	}
	
	T getXMaximum(){
		//list does not provide the random access iterator required 
		//by the common sort algorithm, so we have to use list's
		//propriety sort method.		
		m_pointsList.sort(xFunc<T>);
		return (*(m_pointsList.rbegin()));
	}
	
	T getXMinimum(){
		m_pointsList.sort(xFunc<T>);
		return (*(m_pointsList.begin()));		
	}

	T getYMaximum(){
		m_pointsList.sort(yFunc<T>);
		return (*(m_pointsList.rbegin()));		
	}
	
	T getYMinimum(){
		m_pointsList.sort(yFunc<T>);
		return (*(m_pointsList.begin()));		
	}

private:
	std::list<T> m_pointsList;
	std::list<T> m_pointsOnHull;
};

/*
template <typename V>
std::ostream& operator<<(std::ostream& ostr, const std::list<V>& pList){
	std::list<V>::iterator litr;	
	ostr << "[ " ;
	for(litr=pList.begin(); litr!=pList.end(); litr++){
		ostr << (*litr) << " ";
	}
	ostr << "]";
	return ostr;
}
*/

#endif /*CONVEXHULL2D_HPP_*/
