#include <iomanip>
#include "StatisticData.h"

StatisticData::StatisticData()
  : density(0.0f), surfaceArea(0.0f), width(0.0f)
  , height(0.0f), depth(0.0f), connectivity(0.0f)
{
}

StatisticData::~StatisticData(){};

ostream& operator<<(ostream& ostr, const StatisticData& sData){
  ostr<< setw(16) << setfill(' ') << sData.density;
  ostr<< setw(16) << setfill(' ') << sData.surfaceArea;
  ostr<< setw(16) << setfill(' ') << sData.width;
  ostr<< setw(16) << setfill(' ') << sData.height;
  ostr<< setw(16) << setfill(' ') << sData.depth;
  ostr<< setw(16) << setfill(' ') << sData.connectivity;
  return ostr;
}

istream& operator>>(istream& istr, StatisticData& sData){
  istr >> sData.density
       >> sData.surfaceArea
       >> sData.width
       >> sData.height
       >> sData.depth
       >> sData.connectivity;
  return istr;
}

const StatisticData StatisticData::operator+(const StatisticData& data)
const
{
  StatisticData newData;
  newData.density = density + data.density;
  newData.surfaceArea = surfaceArea + data.surfaceArea;
  newData.width = width + data.width;
  newData.height = height + data.height;
  newData.depth = depth + data.depth;
  newData.connectivity = connectivity + data.connectivity;
  return (newData);
}

StatisticData& StatisticData::operator+=(const StatisticData& data)
{
  density += data.density;
  surfaceArea += data.surfaceArea;
  width += data.width;
  height += data.height;
  depth += data.depth;
  connectivity += data.connectivity;
    
  return (*this);
}

StatisticData& StatisticData::operator/=(const float f)
{    
  density /= f;
  surfaceArea /= f;
  width /= f;
  height /= f;
  depth /= f;
  connectivity /= f;

  return (*this);
}

