/**
 * XMLElement, utility class used to output class state into XML format.* 
 * 
 */
#ifndef XMLELEMENT_H_
#define XMLELEMENT_H_

#include <string>
#include <vector>
#include <map>
#include <iostream>

using namespace std;

class XMLElement
{
public:
	XMLElement();
	void setElementName(const string& inName);
	void setAttribute(const string& inAttrName, const string& inAttrValue);
	void addSubElement(const XMLElement* inElement);
	//Setting a text node will override any nested elements.
	void setTextNode(const string& inValue);
	friend ostream& operator<<(ostream& outStream, const XMLElement& inElem);
	//virtual ~XMLElement();
	
protected:
  void writeToStream(ostream& outStream, int inIndentLevel=0) const;
  void indentStream(ostream& outStream, int inIndentLevel) const;
  
private:
  string                      mElementName;
  map<string, string>         mAttributes;
  vector<const XMLElement*>   mSubElements;
  string                      mTextNode;	
};

#endif /*XMLELEMENT_H_*/
