#ifndef UTILS_H
#define UTILS_H

#define EPSILON 0.00001f   //The highest precision for float, don't change it.
#define GL_PI   3.14159f
#define E_CONST 2.71828f

float randomAngle();
float randomHalfAngle();
float randomAcuteAngle();
float randomSmallAngle();
float randomSmallAngle(float temptureConst);
float randomSpeed(float baseSpeed);

/**
 * Normalize the angle to be in the range of [0, 2*GL_PI]
 * 
 */
float normalAngle(float angle);

/**
 * Compute the probability of diffusion based on free energy and tempture constant.
 * 
 */
float diffusionProbability(float freeEnergy, float temptureConst);
float diffusionProbability2(float freeEnergy, float temptureConst);

#endif
