#include <iostream>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include "SimuModel.h"
#include "XMLFileManager.h"

using namespace std;
/**
 * The original version of simulator did not consider the situation where 
 * computing time is limited. This version addressed the reentrance issue,
 * which means that the simulation can be restarted after termination due 
 * to computing time limitation.
 */  

int main(int argc, char *argv[])
{
  srand(time(NULL));
  SimuModel * simuModel;
  if(argc==3){
	// check to see whether the trace file already exists.
	ifstream traceFile;
	traceFile.open(argv[2], ios::in);
	// trace file exists
	if(traceFile.is_open()){
		cout << "Simulation restarted from trace file " << argv[2] << " is running ......" << endl;
		//SimuContext* context = SimuContext::getInstance();
		//Aggregate* aggregate = new Aggregate();
		//XMLFileManager xmlManager;
		//xmlManager.loadTrace(argv[2], context, aggregate);
		//context->save(cout);
		simuModel = new SimuModel(argv[2]);
		simuModel->run();
		//cout << "done" << endl;			
	}
	else{ // trace file does not exist
		cout << "Simulation with profile " << argv[1] << " is running ......" << endl;
		simuModel = new SimuModel(argv[1], argv[2]);
		//simuModel->setup();
		simuModel->run();
	}
  }
  else{
	  cout << "Usage:" << endl;
	  cout << "\t./dlasimulator contextfilename tracefilename" << endl;
  }
}
