# Generate network files that can be read by tyna from
# simulation traces.
#
# Command line parameters:
#   dirsource: the directory where trace files are located
#   dirtarget: the directory where generated files will be saved

#!/usr/bin/perl -w

use File::stat;
use strict;


my ($dirSource, $dirTarget) = @ARGV;

#$fileNumber = 1;

if(!defined($dirSource) || !defined($dirTarget)){
  die "Source or target directory is missed !\n\tUsage:\n\t\tperl generateNetworks.pl dirSoruce dirTarget\n";
}

if(!stat($dirSource)){
  die "\nError: \n\tSource directory: '$dirSource' does not exist !\n";
}

if(!stat($dirTarget)){
  if(!mkdir($dirTarget)){ # 1: succeeded, 0: failed.  
    die "\nError: \n\tMake target directory : '$dirTarget' failed !\n"
  }
}

&generateGraph($dirSource, $dirTarget);

sub generateGraph(){
  my ($sourceDir, $targetDir)=@_;
  print "$sourceDir  --- $targetDir\n";

  opendir(SOURCEALLDIR, $sourceDir);
  open(INDEXFILE, ">$targetDir/indexfile.txt");

  my ($eachDir );

  while(defined($eachDir = readdir(SOURCEALLDIR))){
  #print $eachFile."\n";
    if(($eachDir !~ /^\./) && ($eachDir =~ /.*round\d+$/)){
      print $eachDir."\n";
      &generateGraphOneRound($sourceDir."/".$eachDir, $targetDir);
    }
  }
  close(INDEXFILE);
  close(SOURCEALLDIR);
}


sub generateGraphs(){
  my ($sourceDir, $targetDir)=@_;
  print "$sourceDir  --- $targetDir\n";
  my ($eachFile, $eachLine, $curElm, @files, $file );
  opendir(SOURCEDIR, $sourceDir);
  @files = readdir(SOURCEDIR);
  close(SOURCEDIR);

  foreach $file (@files){
    #next if($file eq "." or $file eq "..");
    if($file =~ /.*round\d+$/){
      print $file."\n";
      &generateGraphs($sourceDir."/".$eachFile, $targetDir);
    }
    else{
      print $file."\n";
    }
  }
  return;
}

sub generateGraphOneRound(){
  my ($sourceDir, $targetDir)=@_;
  print "$sourceDir  --- $targetDir\n";
  my ($eachFile, $eachLine, $curElm, @files, $file, $roundSerial );

  if($sourceDir=~ /.*\/(round\d+)/){
    $roundSerial = $1;
  }

  opendir(SOURCEDIR, $sourceDir);
  while(defined($eachFile = readdir(SOURCEDIR))){
    #print $eachFile."\n";
    if( $eachFile !~ /\.$/ && $eachFile =~ m/^trace(.*).xml$/i){
      print $eachFile."\n";
      #print ">$targetDir/$roundSerial"."-graph".$1.".txt\n";
      open(TRACEFILE, $sourceDir."/".$eachFile);
      open(OUTFILE, ">$targetDir/$roundSerial$1.txt");
      print INDEXFILE "$roundSerial$1.txt\n";
      $curElm = "";
      while(defined($eachLine = <TRACEFILE>)){
        #print "$eachLine\n";
        if($eachLine =~ /^<element\sid=\"(\d+)\"/){
          #if(length($curElm)>0){
          #  #$outLine=$outLine."\n";
          #  #print OUTFILE $outLine;
          #  #print $outLine;
          #  $curElm = "";
          #}
          $curElm = $1;
        }
        else{
          if($eachLine =~ /id=\"(\d+)\"\/>$/){
            #print "$eachLine\n";
            #print "$1\n";
            #$outLine = $outLine."\t$1";
            #if($1 > $curElm){
              print OUTFILE $curElm."\t$1\n";
            #}
          }
        }
      }
      #$outLine = $outLine."\n";
      #print OUTFILE $outLine;
      close(OUTFILE);
      close(TRACEFILE);
      #print "$eachFile\n";
    }
  }
  closedir(SOURCEDIR);
}
