#
# Modify files in place
# usage:
#      perl modifyFilesInPlace.pl dir fileMatchPattern wordMatchPattern oldWord newWord
#
use strict;

my ($targetDir, $fileMatchPattern, $wordMatchPattern, $oldWord, $newWord) = @ARGV;

if(!defined($targetDir) || !defined($fileMatchPattern) || !defined($wordMatchPattern) || !defined($oldWord) || !defined($newWord)){
  die "One or more command line parameters are missed !\n\tUsage:\n\t\tperl modifyFilesInPlace.pl dir fileMatchPattern wordMatchPattern oldWord newWord\n";
}

if(!stat($targetDir)){
  die "\nError: \n\tTarget directory: '$targetDir' does not exist !\n";
}

my ($eachFile, $eachLine);
opendir(TARGETDIR, $targetDir);
#print $fileExt."\n";
while(defined($eachFile=readdir(TARGETDIR))){
  if($eachFile =~ /$fileMatchPattern/){
    #print $eachFile."\n";
    &processFile("$targetDir/$eachFile", $wordMatchPattern, $oldWord, $newWord);
  }
}
close(TARGETDIR);

sub processFile(){
  my ($fileName, $matchPattern, $oldWord, $newWord) = @_;
  print "$fileName - $oldWord - $newWord \n";

  my ($eachLine);
  open(OLDFILE, "< $fileName");
  open(NEWFILE, "> $fileName-new");
  while (<OLDFILE>){
    if($_ =~ /$matchPattern/){
      print $_."\n";
      $_ =~ s/$oldWord/$newWord/;
      print $_."\n";
    }
    print NEWFILE $_;
  }
  close(NEWFILE);
  close(OLDFILE);
  unlink($fileName);
  rename("$fileName-new", $fileName);
}
