#############################################
#
#Submit the .sh job in the target directory
#to the cluster.
#
#############################################
#!/usr/bin/perl

use strict;
use File::stat;

if(!(scalar(@ARGV)>0) || scalar(@ARGV)<2){
  print "Usage:\n";
  print "perl submitJobs.pl \" targetDirectory jobFilePattern\" \n";
  print "Example: \n";
  die "perl collectSpecificStatisticData.pl \"../../simulationdata/diffusion\" \"^try\\d*\.sh\$\"\n";  
}

my $targetDir = $ARGV[0];
my $jobFilePattern = $ARGV[1];

if(!stat($targetDir)){
  die "\nError: \n\ttarget directory: '$targetDir' does not exist !\n";
}

opendir(TARGETDIR, $targetDir);

my $eachFile;
#print $fileExt."\n";
while(defined($eachFile=readdir(TARGETDIR))){
  if($eachFile =~ /$jobFilePattern/){
    print $eachFile."\n";
    system("qsub -q long.q $targetDir/$eachFile");    
  }
}
close(TARGETDIR);

