
#include "WidgetMovement.h"
//#include <QVBoxLayout>
#include <QGridLayout>
#include <QLabel>
#include <iostream>

using namespace std;

WidgetMovement::WidgetMovement(QWidget * parent)
  :QWidget(parent)
{
	   xMov = 0;
     yMov = 0;
     zMov = 0;
     xSlider = createSlider();
     ySlider = createSlider();
     zSlider = createSlider();

     connect(xSlider, SIGNAL(valueChanged(int)), this, SLOT(setXMovement(int)));
     //connect(glWidget, SIGNAL(xRotationChanged(int)), xSlider, SLOT(setValue(int)));
     connect(ySlider, SIGNAL(valueChanged(int)), this, SLOT(setYMovement(int)));
     //connect(glWidget, SIGNAL(yRotationChanged(int)), ySlider, SLOT(setValue(int)));
     connect(zSlider, SIGNAL(valueChanged(int)), this, SLOT(setZMovement(int)));
     //connect(glWidget, SIGNAL(zRotationChanged(int)), zSlider, SLOT(setValue(int)));

     QLabel* labelx = new QLabel("X:");
     QLabel* labely = new QLabel("Y:");
     QLabel* labelz = new QLabel("Z:");
     QGridLayout * gridLayout = new QGridLayout();
     gridLayout->addWidget(labelx, 0, 0);
     gridLayout->addWidget(xSlider, 0, 1);
     gridLayout->addWidget(labely, 1, 0);
     gridLayout->addWidget(ySlider, 1, 1);
     gridLayout->addWidget(labelz, 2, 0);
     gridLayout->addWidget(zSlider, 2, 1);          
     setLayout(gridLayout);
     
     xSlider->setValue(0);
     ySlider->setValue(0);
     zSlider->setValue(0);
}

WidgetMovement::~WidgetMovement(){}

QSlider *WidgetMovement::createSlider()
{
  QSlider *slider = new QSlider(Qt::Horizontal);
  slider->setRange(-1000, 1000);
  slider->setSingleStep(10);
  slider->setPageStep(50);
  slider->setTickInterval(50);
  slider->setTickPosition(QSlider::TicksRight);
  return slider;
}
 
void WidgetMovement::setXMovement(int offset)
{  
  emit xSetMovementChanged((float)offset);
}

void WidgetMovement::setYMovement(int offset)
{ 	
  emit ySetMovementChanged((float)offset);
}

void WidgetMovement::setZMovement(int offset)
{	
  emit zSetMovementChanged((float)offset);
}
  
QSize WidgetMovement::minimumSizeHint() const
{
  return QSize(50, 50);
}

QSize WidgetMovement::sizeHint() const
{
  return QSize(200, 100);
}

