#ifndef WIDGETMOVEMENT_H_
#define WIDGETMOVEMENT_H_

#include <QWidget>
#include <QSlider>

class WidgetMovement : public QWidget
{
	Q_OBJECT
	
public:
  WidgetMovement(QWidget* parent=0);
  ~WidgetMovement();
  QSize minimumSizeHint() const;
  QSize sizeHint() const;
    
public slots:
  void setXMovement(int step);
  void setYMovement(int step);
  void setZMovement(int step);

signals:
  void xSetMovementChanged(float offset);
  void ySetMovementChanged(float offset);
  void zSetMovementChanged(float offset);
  
private:
  QSlider *createSlider();

  QSlider *xSlider;
  QSlider *ySlider;
  QSlider *zSlider;     

  int xMov;
  int yMov;
  int zMov;
  
};
#endif /*WIDGETMOVEMENT_H_*/
