#include "WidgetRotation.h"
#include <QLabel>
#include <QGridLayout>
#include <iostream>

using namespace std;

WidgetRotation::WidgetRotation(QWidget * parent)
  :QWidget(parent)
{
	   xRot = 0;
     yRot = 0;
     zRot = 0;
     xSlider = createSlider();
     ySlider = createSlider();
     zSlider = createSlider();

     connect(xSlider, SIGNAL(valueChanged(int)), this, SLOT(setXRotation(int)));
     //connect(glWidget, SIGNAL(xRotationChanged(int)), xSlider, SLOT(setValue(int)));
     connect(ySlider, SIGNAL(valueChanged(int)), this, SLOT(setYRotation(int)));
     //connect(glWidget, SIGNAL(yRotationChanged(int)), ySlider, SLOT(setValue(int)));
     connect(zSlider, SIGNAL(valueChanged(int)), this, SLOT(setZRotation(int)));
     //connect(glWidget, SIGNAL(zRotationChanged(int)), zSlider, SLOT(setValue(int)));

     QLabel* labelx = new QLabel("X:");
     QLabel* labely = new QLabel("Y:");
     QLabel* labelz = new QLabel("Z:");
     QGridLayout * gridLayout = new QGridLayout();
     gridLayout->addWidget(labelx, 0, 0);
     gridLayout->addWidget(xSlider, 0, 1);
     gridLayout->addWidget(labely, 1, 0);
     gridLayout->addWidget(ySlider, 1, 1);
     gridLayout->addWidget(labelz, 2, 0);
     gridLayout->addWidget(zSlider, 2, 1);          
     setLayout(gridLayout);
     

     xSlider->setValue(0);
     ySlider->setValue(0);
     zSlider->setValue(0);
}

WidgetRotation::~WidgetRotation(){}

QSlider *WidgetRotation::createSlider()
{
  QSlider *slider = new QSlider(Qt::Horizontal);
  slider->setRange(0, 360);
  slider->setSingleStep(5);
  slider->setPageStep(30);
  slider->setTickInterval(30);
  slider->setTickPosition(QSlider::TicksRight);
  return slider;
}
 
void WidgetRotation::setXRotation(int angle)
{
  emit xSetRotationChanged(angle);
}

void WidgetRotation::setYRotation(int angle)
{ 	
  emit ySetRotationChanged(angle);
}

void WidgetRotation::setZRotation(int angle)
{	
  emit zSetRotationChanged(angle);
}
  
QSize WidgetRotation::minimumSizeHint() const
{
  return QSize(50, 50);
}

QSize WidgetRotation::sizeHint() const
{
  return QSize(200, 100);
}
