#ifndef WIDGETROTATION_H_
#define WIDGETROTATION_H_

#include <QWidget>
#include <QSlider>
 
class WidgetRotation : public QWidget{
     Q_OBJECT
     	
public:
	WidgetRotation(QWidget * parent=0);
	~WidgetRotation();
    QSize minimumSizeHint() const;
    QSize sizeHint() const;
	
public slots:
     void setXRotation(int angle);
     void setYRotation(int angle);
     void setZRotation(int angle);

signals:
     void xSetRotationChanged(int angle);
     void ySetRotationChanged(int angle);
     void zSetRotationChanged(int angle);

private:
     QSlider *createSlider();

     QSlider *xSlider;
     QSlider *ySlider;
     QSlider *zSlider;	
     
     int xRot;
     int yRot;
     int zRot;
};
#endif
