#include "WidgetZoom.h"

//#include <QVBoxLayout>
#include <QGridLayout>
#include <iostream>
#include <sstream>
#include <string>

using namespace std;

WidgetZoom::WidgetZoom(QWidget * parent)
  :QWidget(parent)
{
	   scale = 1.0f;
     scaleSlider = createSlider();

     connect(scaleSlider, SIGNAL(valueChanged(int)), this, SLOT(setZoomScale(int)));

     //QVBoxLayout *mainLayout = new QVBoxLayout;
     //mainLayout->addWidget(scaleSlider);
     //setLayout(mainLayout);
     
     QLabel *emptyLabel = new QLabel(" ");
          
     QLabel *tLabel = new QLabel("Scale:");
     
     scaleLabel = new QLabel("1");
     QGridLayout *gridLayout = new QGridLayout;
     gridLayout->addWidget(emptyLabel, 0, 0, 1, 2);     
     gridLayout->addWidget(scaleSlider, 1, 0, 1, 2);
     gridLayout->addWidget(tLabel, 2, 0);     
     gridLayout->addWidget(scaleLabel, 2, 1);
     gridLayout->addWidget(emptyLabel, 3, 0, 1, 2);     
     setLayout(gridLayout);
     scaleSlider->setValue(0);
}

WidgetZoom::~WidgetZoom(){}

QSlider *WidgetZoom::createSlider()
{
  QSlider *slider = new QSlider(Qt::Horizontal);
  slider->setRange(-100, 100);
  slider->setSingleStep(5);
  slider->setPageStep(10);
  slider->setTickInterval(10);
  slider->setTickPosition(QSlider::TicksRight);
  return slider;
}
 
void WidgetZoom::setZoomScale(int step)
{
	float tmpScale;
  if(step >= 0){
    tmpScale = (scale + (float)(step)/10.0f);
  }
  else{
    tmpScale =(scale + (float)(step)/100.0f);  	
  }
  
  ostringstream s;
  s << tmpScale;  
  scaleLabel->setText(QString(s.str().c_str()));
  
  emit setZoomChanged(tmpScale);
}
 
QSize WidgetZoom::minimumSizeHint() const
{
  return QSize(50, 50);
}

QSize WidgetZoom::sizeHint() const
{
  return QSize(200, 100);
}
